
function OUCN:List_SetFrameVars(frame)
  if (frame) then
    frame.update = false;
    frame.alpha = 0;
    frame.alphaTime = 0;
    frame.timeShown = 0;
    frame.delayer = 0;
    frame.fadeIn = false;
    frame:SetText("");
  else
    OUCN.vars.list.clearFrame = 0;
    OUCN.vars.list.currentFrame = 0;
    OUCN.vars.list.activeCDsStored = false;
    OUCN.vars.list.activeCDs = {};
    local frame;
    for n=1, OUCN.vars.cooldownListMax do
      frame = OUCN.vars.frames.list["text"..n];
      frame.update = false;
      frame.alpha = 0;
      frame.alphaTime = 0;
      frame.timeShown = 0;
      frame.delayer = 0;
      frame:SetText("");
    end
  end
end


function OUCN:List_OnUpdate(arg1)
  if (OUCN.vars.allowMove or not OUCN.vars.enabled) then
    return;
  end

  local i, v, n, frame, alphaDelayer, delayer, list, count, cooldown, cooldownString;
  local doUpdate = false;

  delayer = this.delayer + arg1;
  if (delayer > OUCN.vars.list.updateFrequency) then
    list, count = OUCN:List_GetList();
    doUpdate = true;
    delayer = 0;
  end

  if (OUCN.vars.list.clearFrame > 0) then
    OUCN:List_SetFrameVars(OUCN.vars.frames.list["text"..OUCN.vars.list.currentFrame]);
    OUCN.vars.list.currentFrame = OUCN.vars.list.currentFrame - 1;
    OUCN.vars.list.activeFrames = OUCN.vars.list.activeFrames - 1;
    delayer = OUCN.vars.list.updateFrequency+1;
    OUCN.vars.list.activeCDs[OUCN.vars.list.clearFrame] = nil;
    OUCN.vars.list.clearFrame = 0;
  end
  this.delayer = delayer;

  if ((GetTime()-OUCN.vars.list.startTime) > (OUCN.vars.list.frameStartDelay*OUCN.vars.list.currentFrame)) then
    if (OUCN.vars.list.currentFrame < OUCN.vars.list.activeFrames) then
      OUCN.vars.list.currentFrame = OUCN.vars.list.currentFrame + 1;
      frame = OUCN.vars.frames.list["text"..OUCN.vars.list.currentFrame];
      frame.fadeIn = true;
      frame.update = true;
    end
  end

  if (doUpdate) then
    n = 1;
    for i, v in pairs(list) do
      if (OUCN.vars.list.activeCDs[v.slotID]) then
        frame = OUCN.vars.frames.list["text"..n];
        n = n + 1;

        if (frame.update) then
          OUCN:List_Fade(frame, arg1);

          if (frame.timeShown <= OUCN.vars.list.timeToShow) then
            if (v.cooldown > 0) then
              if (oucnSettings.useColorFade and v.cooldown < 10) then
                frame:SetTextColor(OUCN:GetColorFade(v.cooldown), frame.alpha);
                OUCN:List_SetAlpha(frame, frame.alpha);
              else
                frame:SetTextColor(1, 1, 1, frame.alpha);
                OUCN:List_SetAlpha(frame, frame.alpha);
              end
              frame:SetText(v.name..": "..v.cooldownString);
            else
              OUCN:List_SetAlpha(frame, 0);
              OUCN.vars.list.clearFrame = v.slotID;
            end
          else
            OUCN:List_SetAlpha(frame, 0);
            frame.update = false;
          end
        end
      end
    end
    if ((GetTime()-OUCN.vars.list.startTime) > OUCN.vars.list.timeToLive) then
      OUCN:List_Hide();
    end
  else
    for n=1, OUCN.vars.list.activeFrames do
      frame = OUCN.vars.frames.list["text"..n];
      if (frame.update) then
        OUCN:List_Fade(frame, arg1);
      end
    end
  end
end


function OUCN:List_Fade(frame, time)
  frame.timeShown = frame.timeShown + time;
  if (frame.fadeIn) then
    frame.alphaTime = frame.alphaTime + time; 
    frame.alpha = frame.alphaTime/OUCN.vars.list.fadeInTime;
    OUCN:List_SetAlpha(frame, frame.alpha);
  else
    if ((OUCN.vars.list.timeToShow-frame.timeShown) < OUCN.vars.list.fadeTime) then
      frame.alphaTime = frame.alphaTime - time; 
      frame.alpha = frame.alphaTime/OUCN.vars.list.fadeTime;
      OUCN:List_SetAlpha(frame, frame.alpha);
    end
  end
end


function OUCN:List_SetAlpha(frame, alpha)
  if (frame.fadeIn) then
    if (frame.alpha >= 1) then
      frame.alpha = 1;
      frame.alphaTime = OUCN.vars.list.fadeTime;
      frame.fadeIn = false;
    else
      frame:SetAlpha(alpha);
    end
  else
    if (frame.alpha >= 0) then
      frame:SetAlpha(alpha);
    end
  end
end


function OUCN:List_Show()
  if (OUCN.vars.list.visible) then
    OUCN:List_Hide();
    return;
  end
  local list, count = OUCN:List_GetList();
  if (count > 0) then
    OUCN.vars.list.activeFrames = count;
    OUCN.vars.list.timeToLive = count*OUCN.vars.list.timeToShow;
    if (count > 1) then
      OUCN.vars.list.timeToLive = OUCN.vars.list.timeToLive-((OUCN.vars.list.timeToShow-OUCN.vars.list.frameStartDelay)*(count-1));
    end
    OUCN.vars.frames.list.main.delayer = OUCN.vars.list.updateFrequency+1;
    OUCN.vars.list.startTime = GetTime();
    OUCN.vars.list.visible = true;
    OUCN.vars.frames.list.main:Show();
  end
end


function OUCN:List_Hide()
  OUCN:List_SetFrameVars();
  OUCN.vars.list.visible = false;
  OUCN.vars.frames.list.main:Hide();
end


function OUCN:List_GetList()
  local i, v, n, cd, cdStr;
  local count = 0;
  local tmpTbl = {};
  for i, v in pairs(OUCN.charSettings.cooldownListID) do
    cd, cdStr = OUCN:GetCooldown(i, v.cdtype);
    if (cd > 0) then
      count = count + 1;
      if (not OUCN.vars.list.activeCDsStored) then
        OUCN.vars.list.activeCDs[i] = true;
      end
    end
    local t = {
      slotID = i,
      cooldown = cd,
      cooldownString = cdStr,
      name = v.name,
    };
    table.insert(tmpTbl, t);
  end
  if (not OUCN.vars.list.activeCDsStored) then
    OUCN.vars.list.activeCDsStored = true;
  end
  table.sort(tmpTbl, function(a, b) return a.cooldown<b.cooldown end);
  return tmpTbl, count;
end


function OUCN:CollectListID(slotID, cdtype)
  local name = OUCN:GetSlotName(slotID, cdtype);
  if (OUCN.charSettings.cooldownListID[slotID]) then
    OUCN.charSettings.cooldownListID[slotID] = nil;
    OUCN:ChatMsg("Removed \""..name.."\" ("..slotID..") from the cooldown watch list.");
  else
    if (#OUCN.charSettings.cooldownListID >= OUCN.vars.cooldownListMax) then
      OUCN:ChatMsg("There's already the maximum of "..OUCN.vars.cooldownListMax.." cooldowns in the watch list, can't add a new one.");
    else
      OUCN.charSettings.cooldownListID[slotID] = {
        name = name,
        cdtype = cdtype,
      };
      OUCN:ChatMsg("Added \""..name.."\" ("..slotID..") to the cooldown watch list.");
    end
  end
end


function OUCN:List_SetSpacing()
  for n=2, OUCN.vars.cooldownListMax do
    OUCN.vars.frames.list["text"..n]:SetPoint("TOP", OUCN.vars.frames.list["text"..(n-1)], "BOTTOM", 0, -OUCN.vars.list.spacing);
  end
end
