
function OUCN:OnUpdate(arg1)
  if (OUCN.vars.allowMove or not OUCN.vars.enabled or OUCN.vars.collectListIDs) then
    return;
  end

  if ((oucnSettings.main.timeToShow-OUCN.vars.main.timeShown) < oucnSettings.main.fadeOutTime) then
    OUCN.vars.main.alphaTime = OUCN.vars.main.alphaTime - arg1;
    OUCN.vars.main.alpha = OUCN.vars.main.alphaTime/oucnSettings.main.fadeOutTime;
    OUCN.vars.frames.countdown.main:SetAlpha(OUCN.vars.main.alpha);
    OUCN.vars.frames.ability.main:SetAlpha(OUCN.vars.main.alpha);
  end

  local delayer = this.delayer + arg1;
  OUCN.vars.main.timeShown = OUCN.vars.main.timeShown + arg1;
  if (delayer > OUCN.vars.main.updateFrequency) then
    if (OUCN.vars.main.timeShown > oucnSettings.main.timeToShow) then
      if (not OUCN.vars.isGCD) then
        OUCN:Updater_Start(OUCN.vars.strings.countdown, OUCN.vars.slotID, OUCN.vars.cdtype, OUCN.vars.booktype);
      end
      OUCN:Hide();
    else
      local cooldown, cooldownString = OUCN:GetCooldown(OUCN.vars.slotID, OUCN.vars.cdtype, OUCN.vars.booktype, false);
      if (cooldown > 0) then
        if (oucnSettings.useColorFade and cooldown < 10) then
          OUCN.vars.frames.countdown.text:SetTextColor(OUCN:GetColorFade(cooldown));
        else
          OUCN.vars.frames.countdown.text:SetTextColor(1, 1, 1);
        end
        OUCN.vars.frames.countdown.text:SetText(cooldownString);
      else
        OUCN:DoReadyFlash(OUCN.vars.strings.countdown, OUCN.vars.slotID, OUCN.vars.cdtype, OUCN.vars.booktype);
        OUCN:Hide();
      end
    end
    delayer = 0;
  end
  this.delayer = delayer;
end


function OUCN:UseAction(slotID)
  if (not OUCN.vars.collectListIDs) then
    local cooldown, cooldownString = OUCN:GetCooldown(slotID, OUCN.vars.strings.action, nil, false);
    if (OUCN:ButtonSpamBlock(slotID, OUCN.vars.strings.action) and cooldown > 0) then
      OUCN.vars.currentSlotID = slotID;
      OUCN:Show(cooldownString, slotID, OUCN.vars.strings.action);
    end
    if (slotID == OUCN.vars.readyFlash.slotID and OUCN.vars.readyFlash.cdType == OUCN.vars.strings.action and OUCN:IsAbilityUsable(OUCN.vars.readyFlash.slotID, OUCN.vars.strings.action)) then
      OUCN:HideReadyFlash();
    end
  else
    OUCN:CollectListID(slotID, OUCN.vars.strings.action);
  end
end


function OUCN:UseInventoryItem(slotID)
  if (not OUCN.vars.collectListIDs) then
    local cooldown, cooldownString = OUCN:GetCooldown(slotID, OUCN.vars.strings.inventory, nil, false);
    if (OUCN:ButtonSpamBlock(slotID, OUCN.vars.strings.inventory) and cooldown > 0) then
      OUCN:Show(cooldownString, slotID, OUCN.vars.strings.inventory);
    end
    if (slotID == OUCN.vars.readyFlash.slotID and OUCN.vars.readyFlash.cdType == OUCN.vars.strings.inventory) then
      OUCN:HideReadyFlash();
    end
  else
    OUCN:CollectListID(slotID, OUCN.vars.strings.inventory);
  end
end


function OUCN:CastPetAction(slotID)
  if (not OUCN.vars.collectListIDs) then
    local cooldown, cooldownString = OUCN:GetCooldown(slotID, OUCN.vars.strings.pet, nil, false);
    if (OUCN:ButtonSpamBlock(slotID, OUCN.vars.strings.pet) and cooldown > 0) then
      OUCN:Show(cooldownString, slotID, OUCN.vars.strings.pet);
    end
    if (slotID == OUCN.vars.readyFlash.slotID and OUCN.vars.readyFlash.cdType == OUCN.vars.strings.pet) then
      OUCN:HideReadyFlash();
    end
  else
    OUCN:CollectListID(slotID, OUCN.vars.strings.pet);
  end
end


function OUCN:CastSpell(spellID, booktype)
  if (not OUCN.vars.collectListIDs) then
    OUCN.vars.currentSlotID = spellID;
    OUCN.vars.booktype = booktype;
    local cooldown, cooldownString = OUCN:GetCooldown(spellID, OUCN.vars.strings.spellbook, booktype, false);
    if (OUCN:ButtonSpamBlock(spellID, OUCN.vars.strings.spellbook) and cooldown > 0) then
      OUCN:Show(cooldownString, spellID, OUCN.vars.strings.spellbook, booktype);
    end
    if (spellID == OUCN.vars.readyFlash.slotID and OUCN.vars.readyFlash.cdType == OUCN.vars.strings.spellbook and OUCN:IsAbilityUsable(OUCN.vars.readyFlash.slotID, OUCN.vars.strings.spellbook)) then
      OUCN:HideReadyFlash();
    end
  else
    OUCN:CollectListID(spellID, OUCN.vars.strings.spellbook, booktype);
  end
end


function OUCN:CastSpellByName(spellName)
  if (not OUCN.vars.collectListIDs) then
    OUCN.vars.currentSlotID = spellName;
    local cooldown, cooldownString = OUCN:GetCooldown(spellName, OUCN.vars.strings.spellname, nil, false);
    if (OUCN:ButtonSpamBlock(spellName, OUCN.vars.strings.spellname) and cooldown > 0) then
      OUCN:Show(cooldownString, spellName, OUCN.vars.strings.spellname);
    end
    if (spellName == OUCN.vars.readyFlash.slotID and OUCN.vars.readyFlash.cdType == OUCN.vars.strings.spellname and OUCN:IsAbilityUsable(OUCN.vars.readyFlash.slotID, OUCN.vars.strings.spellname)) then
      OUCN:HideReadyFlash();
    end
  else
    OUCN:CollectListID(spellName, OUCN.vars.strings.spellname);
  end
end


function OUCN:DoReadyFlash(frame, slotID, cdType, booktype)
  if (oucnSettings.readyFlash[frame].show) then
    if ((OUCN.vars.wasGCD) or (oucnSettings.readyFlash[frame].onlyInCombat and not InCombatLockdown()) or (not OUCN:IsAbilityUsable(frame, slotID, cdType, booktype))) then
      if (OUCN.vars.wasGCD) then
        OUCN.vars.wasGCD = false;
      end
      return;
    end
    OUCN.vars.readyFlash.slotID = slotID;
    OUCN.vars.readyFlash.cdType = cdType;
    local f = OUCN.vars.frames.readyFlash;
    local x, y = OUCN.vars.frames[frame].main:GetCenter();
    local model, offsetX, offsetY, angle = OUCN:GetModel(oucnSettings.readyFlash[frame].model);
    f:SetModel(model);
    f:SetModelScale(oucnSettings.readyFlash[frame].scale);
    if (angle) then
      f:SetFacing(angle*math.pi/180);
    else
      f:SetFacing(0);
    end
    f:SetAlpha(oucnSettings.readyFlash[frame].alpha);
    f:ClearAllPoints();
    f:SetPoint("CENTER", OUCN.vars.frames[frame].main, "CENTER", 0, 0);
    f:SetPosition(offsetX*(x/UIParent:GetWidth()), offsetY*(y/UIParent:GetHeight()), 1);
    f:SetSequence(0);
    f:SetSequenceTime(0, 0);
    f:Show();
  end
end


function OUCN:HideReadyFlash()
  OUCN.vars.readyFlash.slotID = 0;
  OUCN.vars.readyFlash.cdType = nil;
  OUCN.vars.frames.readyFlash:Hide();
end


function OUCN:GetModel(name)
  if (not OUCN.vars.readyFlash.models[name]) then
    name = "Battle Shout";
  end
  return OUCN.vars.readyFlash.models[name].model, OUCN.vars.readyFlash.models[name].offsetX, OUCN.vars.readyFlash.models[name].offsetY, OUCN.vars.readyFlash.models[name].angle;
end


function OUCN:Show(cooldown, slotID, cdtype, booktype)
  if (OUCN.vars.enabled) then
    if (OUCN.vars.isGCD) then
      OUCN.vars.wasGCD = true;
    end
    OUCN:HideReadyFlash();
    OUCN.vars.slotID = slotID;
    OUCN.vars.cdtype = cdtype;
    OUCN.vars.buttonSpamBlock.slotID = 0;
    OUCN.vars.buttonSpamBlock.cdType = nil;
    local name = tostring(OUCN:GetSlotName(slotID, cdtype, booktype));
    if (name == "|cff"..oucnSettings.colors.GCD..OUCN.vars.strings.GCD.."|r") then
      if (UnitCastingInfo("player") or UnitChannelInfo("player")) then
        return;
      end
    end
    if (OUCN.vars.usePrefix) then
      if (cdtype == OUCN.vars.strings.inventory or cdtype == OUCN.vars.strings.pet) then
        name = "|cff"..oucnSettings.colors.prefix..OUCN.vars.strings.prefixes[cdtype]..":|r "..name;
      end
    end
    OUCN.vars.main.timeShown = 0;
    OUCN.vars.main.alpha = 1;
    OUCN.vars.main.alphaTime = oucnSettings.main.fadeOutTime;
    OUCN.vars.frames.countdown.main:SetAlpha(OUCN.vars.main.alpha);
    OUCN.vars.frames.countdown.text:SetText(cooldown);
    if (oucnSettings.showAbility) then
      OUCN.vars.frames.ability.main:SetAlpha(OUCN.vars.main.alpha);
      OUCN.vars.frames.ability.text:SetText(name);
      OUCN.vars.frames.ability.main:Show();
    end
    OUCN.vars.frames.countdown.main:Show();
  end
end


function OUCN:Hide()
  OUCN.vars.frames.countdown.main:Hide();
  OUCN.vars.frames.ability.main:Hide();
  OUCN.vars.cdtype = nil;
  OUCN.vars.itemName = nil;
  OUCN.vars.slotID = 0;
end


function OUCN:GetSlotName(slotID, cdtype, booktype)
  local name = nil;
  if ((OUCN.vars.isGCD) and (not OUCN.vars.collectListIDs)) then
    name = "|cff"..oucnSettings.colors.GCD..OUCN.vars.strings.GCD.."|r";
  else
    if (cdtype == OUCN.vars.strings.action) then
      if (OUCN.vars.actions[slotID]) then
        name = OUCN.vars.actions[slotID].name;
      end
      if (not name) then
        OUCN:IndexActions(slotID);
        name = OUCN.vars.actions[slotID].name;
      end
      if (OUCN.vars.actions[slotID].isMacro) then
        local item = GetMacroItem(name);
        local spell = GetMacroSpell(name);
        if (item) then
          name = item;
        elseif (spell) then
          name = spell;
        end
      end
    elseif (cdtype == OUCN.vars.strings.spellbook) then
      OUCN.vars.itemName = GetSpellName(slotID, booktype);
      name = OUCN.vars.itemName;
    elseif (cdtype == OUCN.vars.strings.spellname) then
      OUCN.vars.itemName = slotID;
      name = OUCN.vars.itemName;
    elseif (cdtype == OUCN.vars.strings.inventory) then
      OUCN.vars.itemName = GetItemInfo(GetInventoryItemLink("player", slotID));
      name = OUCN.vars.itemName;
    elseif (cdtype == OUCN.vars.strings.pet) then
      OUCN.vars.itemName = GetPetActionInfo(slotID);
      name = OUCN.vars.itemName;
    end
  end
  return name;
end


function OUCN:GetColorFade(cooldown)
  local r, g, b;
  local val = cooldown/10;
  if (val > 0.5) then
    r = 1;
    g = (1-val)*2;
  else
    r = val*2;
    g = 1;
  end
  b = 0.1;
  return r, g, b;
end


function OUCN:GetCooldown(slotID, cdtype, booktype, silent)
  local cooldownString = "";
  local func = nil;
  local cooldown = 0;
  local start, duration, enabled;
  local curTime = GetTime();
  if (cdtype == OUCN.vars.strings.action) then
    start, duration, enabled = GetActionCooldown(slotID);
  elseif (cdtype == OUCN.vars.strings.spellbook) then
    start, duration, enabled = GetSpellCooldown(slotID, booktype);
  elseif (cdtype == OUCN.vars.strings.spellname) then
    start, duration, enabled = GetSpellCooldown(slotID);
  elseif (cdtype == OUCN.vars.strings.inventory) then
    start, duration, enabled = GetInventoryItemCooldown("player", slotID);
  elseif (cdtype == OUCN.vars.strings.pet) then
    start, duration, enabled = GetPetActionCooldown(slotID);
  end
  OUCN.vars.isGCD = false;
  if (start and start > 0) then
    cooldown = (duration-(curTime-start));
    if ((cooldown == duration) or ((curTime-start < OUCN.vars.castIgnoreTime) and (curTime-start <= OUCN.vars.GCDtime))) then
      cooldown = 0;
    else
      if ((duration == OUCN.vars.GCDtime) and (curTime-start <= OUCN.vars.GCDtime)) then
        OUCN.vars.isGCD = true;
        if (not oucnSettings.showGCD) then
          cooldown = 0;
        end
      end
      if (cooldown > 0 and not silent) then
        cooldownString = OUCN:FormatTime(cooldown);
      end
    end
  end
  return cooldown, cooldownString;
end


function OUCN:FormatTime(cooldown)
  local timeType = nil;
  if (cooldown >= 3540) then
    timeType = OUCN.vars.strings.timeTypes.hours;
    cooldownString = format("%.0f", math.floor((cooldown+1800)/3600));
  elseif (cooldown >= 60) then
    timeType = OUCN.vars.strings.timeTypes.minutes;
    cooldownString = format("%.0f", math.floor((cooldown+30)/60));
  elseif (cooldown < 10) then
    timeType = OUCN.vars.strings.timeTypes.fractions;
    if (oucnSettings.useFractions) then
      cooldownString = format("%1.1f", cooldown);
    else
      cooldownString = format("%.0f", cooldown);
    end
  else
    timeType = OUCN.vars.strings.timeTypes.seconds;
    cooldownString = format("%.0f", cooldown);
  end
  if (oucnSettings.useColors) then
    if (timeType ~= "fractions" or (timeType == "fractions" and not oucnSettings.useColorFade)) then
      cooldownString = "|cff"..oucnSettings.colors[timeType]..cooldownString.."|r";
    end
  end
  if (oucnSettings.useHMS) then
    cooldownString = cooldownString.."|cff"..oucnSettings.colors.HMS..OUCN.vars.strings.HMS[timeType].."|r"
  end
  if (cooldown < 11 and oucnSettings.useFractions) then
    OUCN.vars.main.updateFrequency = OUCN.vars.updateFrequencies.fractions;
  elseif (cooldown < 11 and not oucnSettings.useFractions) then
    OUCN.vars.main.updateFrequency = OUCN.vars.updateFrequencies[OUCN.vars.strings.timeTypes.seconds];
  else
    OUCN.vars.main.updateFrequency = OUCN.vars.updateFrequencies[timeType];
  end
  return cooldownString;
end


function OUCN:IndexActions(slotID)
  local ScanSlot = function(slotID)
    local frameName = OUCN.vars.frames.tooltip:GetName();
    local texture, text, isMacro;
    isMacro = true;
    texture = GetActionTexture(slotID);
    text = GetActionText(slotID);
    if (texture) then
      OUCN.vars.frames.tooltip:SetAction(slotID);
      if (not text) then
        isMacro = false;
        text = getglobal(frameName.."TextLeft1"):GetText();
      end
      if (text) then
        OUCN.vars.actions[slotID] = {name=text, isMacro=isMacro};
      end
      OUCN.vars.frames.tooltip:ClearLines();
    end
  end

  OUCN.vars.frames.tooltip:SetOwner(UIParent, "ANCHOR_NONE");

  if (slotID) then
    ScanSlot(slotID);
  else
    if (OUCN.vars.indexed) then
      return;
    end
    for id=1, 120 do
      ScanSlot(id);
    end
    OUCN.vars.indexed = true;
  end
  OUCN.vars.frames.tooltip:Hide()
end


function OUCN:IsAbilityUsable(frame, slotID, cdType, booktype)
  local returnValue = true;
  if (cdType == OUCN.vars.strings.action) then
    local usable, power = IsUsableAction(slotID);
    local range = IsActionInRange(slotID);
    if (oucnSettings.readyFlash[frame].checks.power and power == nil) then
      returnValue = false;
    elseif (oucnSettings.readyFlash[frame].checks.range and ActionHasRange(slotID) and range ~= 1) then
      returnValue = false;
    elseif (oucnSettings.readyFlash[frame].checks.other and usable == nil) then
      returnValue = false;
    end
  elseif (cdType == OUCN.vars.strings.spellbook) then
    local usable, power = IsUsableSpell(slotID, booktype);
    local range = IsSpellInRange(slotID, OUCN.vars.booktype);
    if (oucnSettings.readyFlash[frame].checks.power and power == nil) then
      returnValue = false;
    elseif (oucnSettings.readyFlash[frame].checks.range and SpellHasRange(slotID, booktype) and range ~= 1) then
      returnValue = false;
    elseif (oucnSettings.readyFlash[frame].checks.other and usable == nil) then
      returnValue = false;
    end
  elseif (cdType == OUCN.vars.strings.spellname) then
    local usable, power = IsUsableSpell(slotID);
    local range = IsSpellInRange(slotID);
    if (oucnSettings.readyFlash[frame].checks.power and power == nil) then
      returnValue = false;
    elseif (oucnSettings.readyFlash[frame].checks.range and SpellHasRange(slotID) and range ~= 1) then
      returnValue = false;
    elseif (oucnSettings.readyFlash[frame].checks.other and usable == nil) then
      returnValue = false;
    end
  end
  return returnValue;
end


function OUCN:ButtonSpamBlock(slotID, cdType)
  local returnState = false;
  if (OUCN.vars.isGCD) then
    returnState = true;
  elseif (OUCN.vars.buttonSpamBlock.cdType == cdType and OUCN.vars.buttonSpamBlock.slotID == slotID) then
    if ((GetTime()-OUCN.vars.buttonSpamBlock.time) > oucnSettings.buttonSpamIgnoreTime) then
      OUCN.vars.buttonSpamBlock.slotID = 0;
      OUCN.vars.buttonSpamBlock.cdType = nil;
      returnState = true;
    else
      OUCN.vars.buttonSpamBlock.time = GetTime();
    end
  else
    OUCN.vars.buttonSpamBlock.slotID = slotID;
    OUCN.vars.buttonSpamBlock.cdType = cdType;
    OUCN.vars.buttonSpamBlock.time = GetTime();
    returnState = true;
  end
  return returnState;
end
