BINDING_HEADER_ONUSECOOLDOWNNOTIFIER = "Viper's On-use Cooldown Notifier";
BINDING_NAME_ONUSECOOLDOWNNOTIFIER_LIST = "Toggle Cooldown Watch List";
BINDING_NAME_ONUSECOOLDOWNNOTIFIER_WATCHER = "Toggle Cooldown Watcher state";

OUCN = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceHook-2.1");
OUCN.SM = AceLibrary("SharedMedia-1.0");
OUCN.SM:Register("statusbar", "LiteStep Light", "Interface\\AddOns\\OnUseCooldownNotifier\\textures\\LiteStep_light");

OUCN.vars = {
  version = "1.3.19",
  name = "On-use Cooldown Notifier",
  realmName = GetCVar("realmName"),
  playerName = UnitName("player"),
  enabled = false,
  castIgnoreTime = 0,
  GCDtime = 0,
  GCDtimes = {
    default = 1.5,
    rogue = 1,
  },
  buttonSpamBlock = {
    slotID = 0,
    cdType = nil,
    time = nil,
  },
  isGCD = false,
  wasGCD = false,
  slotID = 0,
  cdtype = nil,
  booktype = nil,
  itemName = nil,
  buttonSpam = 0,
  currentSlotID = 0,
  allowMove = false,
  isMoving = false,
  indexed = false,
  collectListIDs = false,
  cooldownListMax = 10,
  actions = {},
  updateFrequencies = {
    hours = 1,
    minutes = 1,
    seconds = 0.5,
    fractions = 0.05,
  },
  defaults = {
    cooldownListID = {},
    framePositions = {},
    showAbility = true,
    useColors = true,
    useColorFade = true,
    useHMS = true,
    useFractions = true,
    usePrefix = true,
    showGCD = true,
    buttonSpamIgnoreTime = 0.3,
    colors = {
      hours = "52cfff",
      minutes = "df5fff",
      seconds = "55dfff",
      fractions = "ffffff",
      ability = "ffdf36",
      GCD = "ff1010",
      prefix = "efdfff",
      HMS = "ffffff",
    },
    font = {
      countdown = "",
      ability = "",
      list = "",
      watcher = "",
      size = {
        countdown = 20,
        ability = 14,
        list = 13,
        watcher = 15,
      },
      outline = {
        countdown = "OUTLINE",
        ability = "OUTLINE",
        list = "OUTLINE",
        watcher = "OUTLINE",
      },
    },
    list = {
      fadeInTime = 0.15,
      fadeOutTime = 0.5,
      timeToShow = 2.75,
    },
    main = {
      fadeOutTime = 0.5,
      timeToShow = 2,
    },
    watcher = {
      statusbar = true,
      ability = true,
      countdown = true,
      texture = "LiteStep Light",
      alpha = 1,
      color = {
        r = 1.0,
        g = 0.65,
        b = 0.1,
      },
      statusbarWidth = -1,
      statusbarHeight = 16,
      colorFade = true,
      fractions = true,
      textOffset = {
        x = 0,
        y = 0,
      },
    },
    readyFlash = {
      watcher = {
        onlyInCombat = true,
        checks = {
          power = true,
          range = true,
          other = true,
        },
        model = "Battle Shout",
        show = true,
        scale = 0.3,
        alpha = 1,
        offset = {
           x = 0,
           y = 0,
        },
      },
      countdown = {
        onlyInCombat = true,
        checks = {
          power = true,
          range = true,
          other = true,
        },
        model = "Battle Shout",
        show = true,
        scale = 0.4,
        alpha = 1,
        offset = {
           x = 0,
           y = 0,
        },
      },
      lastUsed = {
        onlyInCombat = true,
        checks = {
          power = true,
          range = true,
          other = true,
        },
        model = "Battle Shout",
        show = true,
        scale = 0.4,
        alpha = 1,
        offset = {
           x = 0,
           y = 0,
        },
      },
    },
    abilityIgnoreTimes = {
      default = 1.0,
      GCD = 0.5,
    },
  },
  perCharacterSettings = {
    cooldownListID = true,
    framePositions = true,
  },
  frames = {
    tooltip = "OnUseCooldownNotifierTooltip",
    readyFlash = "OnUseCooldownNotifierReadyFlashFrame",
    updater = "OnUseCooldownNotifierUpdaterFrame",
    countdown = {
      main = "OnUseCooldownNotifierCountdownFrame",
      text = "OnUseCooldownNotifierCountdownFrameText",
    },
    ability = {
      main = "OnUseCooldownNotifierAbilityFrame",
      text = "OnUseCooldownNotifierAbilityFrameText",
    },
    list = {
      main = "OnUseCooldownNotifierListFrame",
      text1 = "OnUseCooldownNotifierListFrameText1",
      text2 = "OnUseCooldownNotifierListFrameText2",
      text3 = "OnUseCooldownNotifierListFrameText3",
      text4 = "OnUseCooldownNotifierListFrameText4",
      text5 = "OnUseCooldownNotifierListFrameText5",
      text6 = "OnUseCooldownNotifierListFrameText6",
      text7 = "OnUseCooldownNotifierListFrameText7",
      text8 = "OnUseCooldownNotifierListFrameText8",
      text9 = "OnUseCooldownNotifierListFrameText9",
      text10 = "OnUseCooldownNotifierListFrameText10",
    },
    watcher = {
      main = "OnUseCooldownNotifierWatherFrame",
      ability = "OnUseCooldownNotifierWatherFrameAbility",
      countdown = "OnUseCooldownNotifierWatherFrameCountdown",
      statusbar = "OnUseCooldownNotifierWatherFrameStatusbar",
    },
    options = {
      main = "OnUseCooldownNotifierOptionsFrame",
    },
  },
  strings = {
    HMS = {
      hours = "h",
      minutes = "m",
      seconds = "s",
      fractions = "",
    },
    timeTypes = {
      hours = "hours",
      minutes = "minutes",
      seconds = "seconds",
      fractions = "fractions",
    },
    action = "action",
    inventory = "inventory",
    pet = "pet",
    spellbook = "spellbook",
    spellname = "spellname",
    GCD = "GCD",
    prefixes = {
      pet = "Pet",
      inventory = "Item",
    },
    countdown = "countdown",
    ability = "ability",
    list = "list",
    watcher = "watcher",
    outlines = {
      none = "",
      normal = "OUTLINE",
      thick = "THICKOUTLINE",
    },
    templates = {
      main = "OnUseCooldownNotifier%sFrame",
      text = "OnUseCooldownNotifier%sFrameText%s",
      child = "OnUseCooldownNotifier%sFrame%s",
    },
  },
  main = {
    alpha = 0,
    timeShown = 0,
    alphaTime = 0,
    updateFrequency = 0.1,
  },
  list = {
    spacing = 2,
    updateFrequency = 0.1,
    timeToShow = 2.75,
    fadeTime = 1,
    fadeInTime = 0.15,
    frameStartDelay = 0.5,
    currentFrame = 0,
    startTime = 0,
    timeToLive = 0,
    activeFrames = 0,
    clearFrame = 0,
    visible = false,
    activeCDsStored = false,
    activeCDs = {},
  },
  watcher = {
    slotID = 0,
    cdType = 0,
  },
  updater = {
    countdown = {
      active = false,
      updateFrequency = 0.1,
      delayer = 0,
      slotID = 0,
      cdType = nil,
    },
  },
  readyFlash = {
    slotID = 0,
    cdType = nil,
    models = {
      ["Arcane Explosion"] = {
        model = "Spells\\Arcaneexplosion_base.mdx",
        offsetX = 19,
        offsetY = 18.8,
      },
      ["Arcane Torrent"] = {
        model = "Spells\\Arcanetorrent.mdx",
        offsetX = 19,
        offsetY = 18.8,
      },
      ["Battle Shout"] = {
        model = "Spells\\Battleshout_cast_base.mdx",
        offsetX = 3.1,
        offsetY = 7,
      },
      ["Challenging Shout"] = {
        model = "Spells\\Challengingshout_cast_base.mdx",
        offsetX = 5.4,
        offsetY = 5.3,
      },
      ["Fel Firenova"] = {
        model = "Spells\\Fel_firenova_area.mdx",
        offsetX = 27.6,
        offsetY = 26.4,
      },
      ["Firenova"] = {
        model = "Spells\\Firenova_area.mdx",
        offsetX = 47,
        offsetY = 46,
      },
      ["Firenova Blue"] = {
        model = "Spells\\Firenova_blue_area.mdx",
        offsetX = 27.8,
        offsetY = 26.2,
      },
      ["Frost Nova"] = {
        model = "Spells\\Frost_nova_area.mdx",
        offsetX = 19,
        offsetY = 18.8,
      },
      ["Intimidating Shout"] = {
        model = "Spells\\Intimidatingshout_cast_base.mdx",
        offsetX = 4.6,
        offsetY = 4.55,
      },
      ["Mana Tide"] = {
        model = "Spells\\Manatideinfuse_base.mdx",
        offsetX = 26.6,
        offsetY = 26.3,
      },
      ["Mutilate (Up)"] = {
        model = "Spells\\Mutilate_impact_chest.mdx",
        offsetX = 4.6,
        offsetY = 2.8,
        angle = 270,
      },
      ["Mutilate (Down)"] = {
        model = "Spells\\Mutilate_impact_chest.mdx",
        offsetX = 4.6,
        offsetY = 2.8,
        angle = 90,
      },
      ["Poison Elemental"] = {
        model = "Spells\\Poisonelemental_impact_base.mdx",
        offsetX = 5.05,
        offsetY = 5.05,
      },
      ["Ragnaros Firenova"] = {
        model = "Spells\\Rag_firenova_area.mdx",
        offsetX = 118.6,
        offsetY = 112,
      },
      ["Starfire"] = {
        model = "Spells\\Starfire_area.mdx",
        offsetX = 30.6,
        offsetY = 30.5,
      },
      ["Summon Pet"] = {
        model = "Spells\\Summonpet_cast_impact_base.mdx",
        offsetX = 3.6,
        offsetY = 2.6,
      },
      ["Victory Rush"] = {
        model = "Spells\\Victory_rush_impact.mdx",
        offsetX = 3.9,
        offsetY = 3.85,
      },
    },
  },
};
